# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`nservicebusservicecontrol`](#nservicebusservicecontrol): Installs and configures Particular's Service Control Monitoring Tool.

#### Private Classes

* `nservicebusservicecontrol::config`: This class handles the configuration of servicecontrol.
* `nservicebusservicecontrol::install`: This class handles the management of the servicecontrol installer and package.

### Defined types

* [`nservicebusservicecontrol::audit_instance`](#nservicebusservicecontrol--audit_instance): Manages Service Control Instances.
* [`nservicebusservicecontrol::instance`](#nservicebusservicecontrol--instance): Manages Service Control Instances.
* [`nservicebusservicecontrol::monitoring_instance`](#nservicebusservicecontrol--monitoring_instance): Manages Service Control Monitoring Instances.
* [`nservicebusservicecontrol::retry_redirect`](#nservicebusservicecontrol--retry_redirect): Manages Retry Redirects.

### Data types

* [`Nservicebusservicecontrol::Log_level`](#Nservicebusservicecontrol--Log_level): Supported log levels for servicecontrol
* [`Nservicebusservicecontrol::Transport`](#Nservicebusservicecontrol--Transport): Supported NServicebus transports

### Tasks

* [`get_instances`](#get_instances): Gets all servicecontrol instances.

### Plans

* [`nservicebusservicecontrol::compact_database`](#nservicebusservicecontrol--compact_database): Compacts the servicecontrol instance's RavenDB Database.
* [`nservicebusservicecontrol::import_failed_messages`](#nservicebusservicecontrol--import_failed_messages): Imports failed error or audit messages.

## Classes

### <a name="nservicebusservicecontrol"></a>`nservicebusservicecontrol`

Installs and configures Particular's Service Control Monitoring Tool.

#### Parameters

The following parameters are available in the `nservicebusservicecontrol` class:

* [`package_ensure`](#-nservicebusservicecontrol--package_ensure)
* [`package_source`](#-nservicebusservicecontrol--package_source)
* [`powershell_package_provider`](#-nservicebusservicecontrol--powershell_package_provider)
* [`license_xml`](#-nservicebusservicecontrol--license_xml)

##### <a name="-nservicebusservicecontrol--package_ensure"></a>`package_ensure`

Data type: `String`

Whether to install the ServiceControl package.

Default value: `'present'`

##### <a name="-nservicebusservicecontrol--package_source"></a>`package_source`

Data type: `Optional[String]`

The package source for the package.

Default value: `undef`

##### <a name="-nservicebusservicecontrol--powershell_package_provider"></a>`powershell_package_provider`

Data type: `Optional[Enum['windowspowershell', 'powershellcore']]`

Whether to use Windows PowerShell or PowerShell Core to install the Particular.ServiceControl.Management PowerShell module.

Default value: `'windowspowershell'`

##### <a name="-nservicebusservicecontrol--license_xml"></a>`license_xml`

Data type: `Optional[String]`

A valid NServiceBus XML License.

Default value: `''`

## Defined types

### <a name="nservicebusservicecontrol--audit_instance"></a>`nservicebusservicecontrol::audit_instance`

Manages Service Control Instances.

#### Parameters

The following parameters are available in the `nservicebusservicecontrol::audit_instance` defined type:

* [`ensure`](#-nservicebusservicecontrol--audit_instance--ensure)
* [`service_control_queue_address`](#-nservicebusservicecontrol--audit_instance--service_control_queue_address)
* [`instance_name`](#-nservicebusservicecontrol--audit_instance--instance_name)
* [`install_path`](#-nservicebusservicecontrol--audit_instance--install_path)
* [`log_path`](#-nservicebusservicecontrol--audit_instance--log_path)
* [`db_path`](#-nservicebusservicecontrol--audit_instance--db_path)
* [`db_index_storage_path`](#-nservicebusservicecontrol--audit_instance--db_index_storage_path)
* [`instance_log_level`](#-nservicebusservicecontrol--audit_instance--instance_log_level)
* [`host_name`](#-nservicebusservicecontrol--audit_instance--host_name)
* [`port`](#-nservicebusservicecontrol--audit_instance--port)
* [`database_maintenance_port`](#-nservicebusservicecontrol--audit_instance--database_maintenance_port)
* [`maximum_concurrency_level`](#-nservicebusservicecontrol--audit_instance--maximum_concurrency_level)
* [`ravendb_log_level`](#-nservicebusservicecontrol--audit_instance--ravendb_log_level)
* [`transport`](#-nservicebusservicecontrol--audit_instance--transport)
* [`display_name`](#-nservicebusservicecontrol--audit_instance--display_name)
* [`connection_string`](#-nservicebusservicecontrol--audit_instance--connection_string)
* [`description`](#-nservicebusservicecontrol--audit_instance--description)
* [`service_account`](#-nservicebusservicecontrol--audit_instance--service_account)
* [`service_account_password`](#-nservicebusservicecontrol--audit_instance--service_account_password)
* [`service_restart_on_config_change`](#-nservicebusservicecontrol--audit_instance--service_restart_on_config_change)
* [`audit_retention_period`](#-nservicebusservicecontrol--audit_instance--audit_retention_period)
* [`time_to_restart_audit_ingestion_after_failure`](#-nservicebusservicecontrol--audit_instance--time_to_restart_audit_ingestion_after_failure)
* [`enable_full_text_search_on_bodies`](#-nservicebusservicecontrol--audit_instance--enable_full_text_search_on_bodies)
* [`expiration_process_timer_in_seconds`](#-nservicebusservicecontrol--audit_instance--expiration_process_timer_in_seconds)
* [`expiration_process_batch_size`](#-nservicebusservicecontrol--audit_instance--expiration_process_batch_size)
* [`data_space_remaining_threshold`](#-nservicebusservicecontrol--audit_instance--data_space_remaining_threshold)
* [`max_body_size_to_store`](#-nservicebusservicecontrol--audit_instance--max_body_size_to_store)
* [`http_default_connection_limit`](#-nservicebusservicecontrol--audit_instance--http_default_connection_limit)
* [`minimum_storage_left_required_for_ingestion`](#-nservicebusservicecontrol--audit_instance--minimum_storage_left_required_for_ingestion)
* [`service_manage`](#-nservicebusservicecontrol--audit_instance--service_manage)
* [`skip_queue_creation`](#-nservicebusservicecontrol--audit_instance--skip_queue_creation)
* [`remove_db_on_delete`](#-nservicebusservicecontrol--audit_instance--remove_db_on_delete)
* [`remove_logs_on_delete`](#-nservicebusservicecontrol--audit_instance--remove_logs_on_delete)
* [`automatic_instance_upgrades`](#-nservicebusservicecontrol--audit_instance--automatic_instance_upgrades)
* [`instance_create_and_upgrade_acknowledgements`](#-nservicebusservicecontrol--audit_instance--instance_create_and_upgrade_acknowledgements)
* [`audit_queue`](#-nservicebusservicecontrol--audit_instance--audit_queue)
* [`audit_log_queue`](#-nservicebusservicecontrol--audit_instance--audit_log_queue)
* [`expose_ravendb`](#-nservicebusservicecontrol--audit_instance--expose_ravendb)
* [`forward_audit_messages`](#-nservicebusservicecontrol--audit_instance--forward_audit_messages)

##### <a name="-nservicebusservicecontrol--audit_instance--ensure"></a>`ensure`

Data type: `Enum['present', 'absent']`

Specifies whether the instance should exist.

##### <a name="-nservicebusservicecontrol--audit_instance--service_control_queue_address"></a>`service_control_queue_address`

Data type: `String`

The ServiceControl queue name to use for plugin messages (e.g. Heartbeats, Custom Checks, Saga Audit, etc ).

##### <a name="-nservicebusservicecontrol--audit_instance--instance_name"></a>`instance_name`

Data type: `String`

Specify the name of the ServiceControl Instance (title).

Default value: `$title`

##### <a name="-nservicebusservicecontrol--audit_instance--install_path"></a>`install_path`

Data type: `Stdlib::Absolutepath`

Specify the directory to use for this ServiceControl Instance.

Default value: `"C:\\Program Files (x86)\\Particular Software\\${instance_name}"`

##### <a name="-nservicebusservicecontrol--audit_instance--log_path"></a>`log_path`

Data type: `Stdlib::Absolutepath`

Specify the directory to use for this ServiceControl Logs.

Default value: `"C:\\ProgramData\\Particular\\ServiceControl\\${instance_name}\\Logs"`

##### <a name="-nservicebusservicecontrol--audit_instance--db_path"></a>`db_path`

Data type: `Stdlib::Absolutepath`

Specify the directory that will contain the nservicebusservicecontrol database for this ServiceControl Instance.

Default value: `"C:\\ProgramData\\Particular\\ServiceControl\\${instance_name}\\DB"`

##### <a name="-nservicebusservicecontrol--audit_instance--db_index_storage_path"></a>`db_index_storage_path`

Data type: `Stdlib::Absolutepath`

Specify the path for the indexes on disk.

Default value: `"${db_path}\\Indexes"`

##### <a name="-nservicebusservicecontrol--audit_instance--instance_log_level"></a>`instance_log_level`

Data type: `Nservicebusservicecontrol::Log_level`

Specify the level of logging that should be used in ServiceControl logs.

Default value: `'Warn'`

##### <a name="-nservicebusservicecontrol--audit_instance--host_name"></a>`host_name`

Data type: `Stdlib::Fqdn`

Specify the hostname to use in the URLACL.

Default value: `'localhost'`

##### <a name="-nservicebusservicecontrol--audit_instance--port"></a>`port`

Data type: `Stdlib::Port`

Specify the port number to listen on. If this is the only ServiceControl instance then 44444 is recommended.

Default value: `44444`

##### <a name="-nservicebusservicecontrol--audit_instance--database_maintenance_port"></a>`database_maintenance_port`

Data type: `Stdlib::Port`

Specify the database maintenance port number to listen on. If this is the only ServiceControl instance then 44445 is recommended.

Default value: `44445`

##### <a name="-nservicebusservicecontrol--audit_instance--maximum_concurrency_level"></a>`maximum_concurrency_level`

Data type: `Integer`

This setting controls how many messages can be processed concurrently (in parallel) by ServiceControl.

Default value: `32`

##### <a name="-nservicebusservicecontrol--audit_instance--ravendb_log_level"></a>`ravendb_log_level`

Data type: `Nservicebusservicecontrol::Log_level`

Specify the level of logging that should be used in ravendb logs.

Default value: `'Warn'`

##### <a name="-nservicebusservicecontrol--audit_instance--transport"></a>`transport`

Data type: `Nservicebusservicecontrol::Transport`

Specify the NServiceBus Transport to use.

Default value: `'MSMQ'`

##### <a name="-nservicebusservicecontrol--audit_instance--display_name"></a>`display_name`

Data type: `String`

Specify the Windows Service Display name. If unspecified the instance name will be used.

Default value: `$instance_name`

##### <a name="-nservicebusservicecontrol--audit_instance--connection_string"></a>`connection_string`

Data type: `Optional[String]`

Specify the connection string to use to connect to the queuing system.

Default value: `undef`

##### <a name="-nservicebusservicecontrol--audit_instance--description"></a>`description`

Data type: `String`

Specify the description to use on the Windows Service for this instance.

Default value: `'A ServiceControl Audit Instance'`

##### <a name="-nservicebusservicecontrol--audit_instance--service_account"></a>`service_account`

Data type: `String`

The Account to run the Windows service.

Default value: `'LocalSystem'`

##### <a name="-nservicebusservicecontrol--audit_instance--service_account_password"></a>`service_account_password`

Data type: `Optional[String]`

The password for the ServiceAccount.

Default value: `undef`

##### <a name="-nservicebusservicecontrol--audit_instance--service_restart_on_config_change"></a>`service_restart_on_config_change`

Data type: `Boolean`

Specify if the servicecontrol instance's windows service should be restarted to pick up changes to its configuration file.

Default value: `true`

##### <a name="-nservicebusservicecontrol--audit_instance--audit_retention_period"></a>`audit_retention_period`

Data type: `String`

Specify thd grace period that faulted messages are kept before they are deleted.

Default value: `'30.00:00:00'`

##### <a name="-nservicebusservicecontrol--audit_instance--time_to_restart_audit_ingestion_after_failure"></a>`time_to_restart_audit_ingestion_after_failure`

Data type: `String`

Specify the maximum time delay to wait before restarting the audit ingestion pipeline after detecting a connection problem. This setting was introduced in ServiceControl version 4.4.1.

Default value: `'00.00:01:00'`

##### <a name="-nservicebusservicecontrol--audit_instance--enable_full_text_search_on_bodies"></a>`enable_full_text_search_on_bodies`

Data type: `Boolean`

Allows full text searches to happen on the body of messages. This setting was introduced in ServiceControl version 4.17.0.

Default value: `true`

##### <a name="-nservicebusservicecontrol--audit_instance--expiration_process_timer_in_seconds"></a>`expiration_process_timer_in_seconds`

Data type: `Integer`

Specifies the number of seconds to wait between checking for expired messages.

Default value: `600`

##### <a name="-nservicebusservicecontrol--audit_instance--expiration_process_batch_size"></a>`expiration_process_batch_size`

Data type: `Integer`

Specifies the batch size to use when checking for expired messages.

Default value: `65512`

##### <a name="-nservicebusservicecontrol--audit_instance--data_space_remaining_threshold"></a>`data_space_remaining_threshold`

Data type: `Integer`

The percentage threshold for the Message database storage space check. If the remaining hard drive space drops below this threshold (as a percentage of the total space on the drive), then the check will fail, alerting the user.

Default value: `20`

##### <a name="-nservicebusservicecontrol--audit_instance--max_body_size_to_store"></a>`max_body_size_to_store`

Data type: `Integer`

Specifies the upper limit on body size to be configured.

Default value: `102400`

##### <a name="-nservicebusservicecontrol--audit_instance--http_default_connection_limit"></a>`http_default_connection_limit`

Data type: `Integer`

Specifies the maximum number of concurrent connections allowed by ServiceControl.

Default value: `100`

##### <a name="-nservicebusservicecontrol--audit_instance--minimum_storage_left_required_for_ingestion"></a>`minimum_storage_left_required_for_ingestion`

Data type: `Integer`

The percentage threshold for the Critical message database storage space check.

Default value: `5`

##### <a name="-nservicebusservicecontrol--audit_instance--service_manage"></a>`service_manage`

Data type: `Boolean`

Specifies whether or not to manage the desired state of the windows service for this instance.

Default value: `true`

##### <a name="-nservicebusservicecontrol--audit_instance--skip_queue_creation"></a>`skip_queue_creation`

Data type: `Boolean`

Normally an instance will attempt to create the queues that it uses. If this flag is set, queue creation will be skipped.

Default value: `false`

##### <a name="-nservicebusservicecontrol--audit_instance--remove_db_on_delete"></a>`remove_db_on_delete`

Data type: `Boolean`

Remove service control instance ravendb database when instance is deleted.

Default value: `false`

##### <a name="-nservicebusservicecontrol--audit_instance--remove_logs_on_delete"></a>`remove_logs_on_delete`

Data type: `Boolean`

Remove service control instance logs when instance is deleted.

Default value: `false`

##### <a name="-nservicebusservicecontrol--audit_instance--automatic_instance_upgrades"></a>`automatic_instance_upgrades`

Data type: `Boolean`

Automatically upgrade the service control monitoring instance when a new version of servicecontrol is installed.

Default value: `true`

##### <a name="-nservicebusservicecontrol--audit_instance--instance_create_and_upgrade_acknowledgements"></a>`instance_create_and_upgrade_acknowledgements`

Data type: `Optional[String]`

Acknowledge mandatory requirements have been met during instance creation and upgrades.

Default value: `undef`

##### <a name="-nservicebusservicecontrol--audit_instance--audit_queue"></a>`audit_queue`

Data type: `String`



Default value: `'audit'`

##### <a name="-nservicebusservicecontrol--audit_instance--audit_log_queue"></a>`audit_log_queue`

Data type: `Optional[String]`



Default value: `'audit.log'`

##### <a name="-nservicebusservicecontrol--audit_instance--expose_ravendb"></a>`expose_ravendb`

Data type: `Boolean`



Default value: `false`

##### <a name="-nservicebusservicecontrol--audit_instance--forward_audit_messages"></a>`forward_audit_messages`

Data type: `Boolean`



Default value: `false`

### <a name="nservicebusservicecontrol--instance"></a>`nservicebusservicecontrol::instance`

Manages Service Control Instances.

#### Parameters

The following parameters are available in the `nservicebusservicecontrol::instance` defined type:

* [`ensure`](#-nservicebusservicecontrol--instance--ensure)
* [`instance_name`](#-nservicebusservicecontrol--instance--instance_name)
* [`install_path`](#-nservicebusservicecontrol--instance--install_path)
* [`log_path`](#-nservicebusservicecontrol--instance--log_path)
* [`db_path`](#-nservicebusservicecontrol--instance--db_path)
* [`db_index_storage_path`](#-nservicebusservicecontrol--instance--db_index_storage_path)
* [`db_logs_path`](#-nservicebusservicecontrol--instance--db_logs_path)
* [`instance_log_level`](#-nservicebusservicecontrol--instance--instance_log_level)
* [`host_name`](#-nservicebusservicecontrol--instance--host_name)
* [`port`](#-nservicebusservicecontrol--instance--port)
* [`database_maintenance_port`](#-nservicebusservicecontrol--instance--database_maintenance_port)
* [`maximum_concurrency_level`](#-nservicebusservicecontrol--instance--maximum_concurrency_level)
* [`retry_history_depth`](#-nservicebusservicecontrol--instance--retry_history_depth)
* [`remote_instances`](#-nservicebusservicecontrol--instance--remote_instances)
* [`expose_ravendb`](#-nservicebusservicecontrol--instance--expose_ravendb)
* [`ravendb_log_level`](#-nservicebusservicecontrol--instance--ravendb_log_level)
* [`error_queue`](#-nservicebusservicecontrol--instance--error_queue)
* [`error_log_queue`](#-nservicebusservicecontrol--instance--error_log_queue)
* [`transport`](#-nservicebusservicecontrol--instance--transport)
* [`display_name`](#-nservicebusservicecontrol--instance--display_name)
* [`connection_string`](#-nservicebusservicecontrol--instance--connection_string)
* [`description`](#-nservicebusservicecontrol--instance--description)
* [`forward_error_messages`](#-nservicebusservicecontrol--instance--forward_error_messages)
* [`service_account`](#-nservicebusservicecontrol--instance--service_account)
* [`service_account_password`](#-nservicebusservicecontrol--instance--service_account_password)
* [`service_restart_on_config_change`](#-nservicebusservicecontrol--instance--service_restart_on_config_change)
* [`error_retention_period`](#-nservicebusservicecontrol--instance--error_retention_period)
* [`time_to_restart_error_ingestion_after_failure`](#-nservicebusservicecontrol--instance--time_to_restart_error_ingestion_after_failure)
* [`disable_external_integrations_publishing`](#-nservicebusservicecontrol--instance--disable_external_integrations_publishing)
* [`enable_full_text_search_on_bodies`](#-nservicebusservicecontrol--instance--enable_full_text_search_on_bodies)
* [`event_retention_period`](#-nservicebusservicecontrol--instance--event_retention_period)
* [`expiration_process_timer_in_seconds`](#-nservicebusservicecontrol--instance--expiration_process_timer_in_seconds)
* [`expiration_process_batch_size`](#-nservicebusservicecontrol--instance--expiration_process_batch_size)
* [`data_space_remaining_threshold`](#-nservicebusservicecontrol--instance--data_space_remaining_threshold)
* [`http_default_connection_limit`](#-nservicebusservicecontrol--instance--http_default_connection_limit)
* [`heartbeat_grace_period`](#-nservicebusservicecontrol--instance--heartbeat_grace_period)
* [`allow_message_editing`](#-nservicebusservicecontrol--instance--allow_message_editing)
* [`notifications_filter`](#-nservicebusservicecontrol--instance--notifications_filter)
* [`minimum_storage_left_required_for_ingestion`](#-nservicebusservicecontrol--instance--minimum_storage_left_required_for_ingestion)
* [`service_manage`](#-nservicebusservicecontrol--instance--service_manage)
* [`skip_queue_creation`](#-nservicebusservicecontrol--instance--skip_queue_creation)
* [`remove_db_on_delete`](#-nservicebusservicecontrol--instance--remove_db_on_delete)
* [`remove_logs_on_delete`](#-nservicebusservicecontrol--instance--remove_logs_on_delete)
* [`automatic_instance_upgrades`](#-nservicebusservicecontrol--instance--automatic_instance_upgrades)
* [`instance_create_and_upgrade_acknowledgements`](#-nservicebusservicecontrol--instance--instance_create_and_upgrade_acknowledgements)

##### <a name="-nservicebusservicecontrol--instance--ensure"></a>`ensure`

Data type: `Enum['present', 'absent']`

Specifies whether the instance should exist.

##### <a name="-nservicebusservicecontrol--instance--instance_name"></a>`instance_name`

Data type: `String`

Specify the name of the ServiceControl Instance (title).

Default value: `$title`

##### <a name="-nservicebusservicecontrol--instance--install_path"></a>`install_path`

Data type: `Stdlib::Absolutepath`

Specify the directory to use for this ServiceControl Instance.

Default value: `"C:\\Program Files (x86)\\Particular Software\\${instance_name}"`

##### <a name="-nservicebusservicecontrol--instance--log_path"></a>`log_path`

Data type: `Stdlib::Absolutepath`

Specify the directory to use for this ServiceControl Logs.

Default value: `"C:\\ProgramData\\Particular\\ServiceControl\\${instance_name}\\Logs"`

##### <a name="-nservicebusservicecontrol--instance--db_path"></a>`db_path`

Data type: `Stdlib::Absolutepath`

Specify the directory that will contain the nservicebusservicecontrol database for this ServiceControl Instance.

Default value: `"C:\\ProgramData\\Particular\\ServiceControl\\${instance_name}\\DB"`

##### <a name="-nservicebusservicecontrol--instance--db_index_storage_path"></a>`db_index_storage_path`

Data type: `Stdlib::Absolutepath`

Specify the path for the indexes on disk.

Default value: `"${db_path}\\Indexes"`

##### <a name="-nservicebusservicecontrol--instance--db_logs_path"></a>`db_logs_path`

Data type: `Stdlib::Absolutepath`

Specify the path for the Esent logs on disk.

Default value: `"${db_path}\\logs"`

##### <a name="-nservicebusservicecontrol--instance--instance_log_level"></a>`instance_log_level`

Data type: `Nservicebusservicecontrol::Log_level`

Specify the level of logging that should be used in ServiceControl logs.

Default value: `'Warn'`

##### <a name="-nservicebusservicecontrol--instance--host_name"></a>`host_name`

Data type: `Stdlib::Fqdn`

Specify the hostname to use in the URLACL.

Default value: `'localhost'`

##### <a name="-nservicebusservicecontrol--instance--port"></a>`port`

Data type: `Stdlib::Port`

Specify the port number to listen on. If this is the only ServiceControl instance then 33333 is recommended.

Default value: `33333`

##### <a name="-nservicebusservicecontrol--instance--database_maintenance_port"></a>`database_maintenance_port`

Data type: `Stdlib::Port`

Specify the database maintenance port number to listen on. If this is the only ServiceControl instance then 33334 is recommended.

Default value: `33334`

##### <a name="-nservicebusservicecontrol--instance--maximum_concurrency_level"></a>`maximum_concurrency_level`

Data type: `Integer`

This setting controls how many messages can be processed concurrently (in parallel) by ServiceControl.

Default value: `10`

##### <a name="-nservicebusservicecontrol--instance--retry_history_depth"></a>`retry_history_depth`

Data type: `Integer`

The depth of retry history.

Default value: `10`

##### <a name="-nservicebusservicecontrol--instance--remote_instances"></a>`remote_instances`

Data type: `Optional[Array[String]]`

Specify an optional array of remote instances.

Default value: `[]`

##### <a name="-nservicebusservicecontrol--instance--expose_ravendb"></a>`expose_ravendb`

Data type: `Boolean`

Specify if the embedded ravendb database should be accessible outside of maintenance mode.

Default value: `false`

##### <a name="-nservicebusservicecontrol--instance--ravendb_log_level"></a>`ravendb_log_level`

Data type: `Nservicebusservicecontrol::Log_level`

Specify the level of logging that should be used in ravendb logs.

Default value: `'Warn'`

##### <a name="-nservicebusservicecontrol--instance--error_queue"></a>`error_queue`

Data type: `String`

Specify ErrorQueue name to consume messages from.

Default value: `'error'`

##### <a name="-nservicebusservicecontrol--instance--error_log_queue"></a>`error_log_queue`

Data type: `Optional[String]`

Specify Queue name to forward error messages to.

Default value: `'error.log'`

##### <a name="-nservicebusservicecontrol--instance--transport"></a>`transport`

Data type: `Nservicebusservicecontrol::Transport`

Specify the NServiceBus Transport to use.

Default value: `'MSMQ'`

##### <a name="-nservicebusservicecontrol--instance--display_name"></a>`display_name`

Data type: `String`

Specify the Windows Service Display name. If unspecified the instance name will be used.

Default value: `$instance_name`

##### <a name="-nservicebusservicecontrol--instance--connection_string"></a>`connection_string`

Data type: `Optional[String]`

Specify the connection string to use to connect to the queuing system.

Default value: `undef`

##### <a name="-nservicebusservicecontrol--instance--description"></a>`description`

Data type: `String`

Specify the description to use on the Windows Service for this instance.

Default value: `'A ServiceControl Instance'`

##### <a name="-nservicebusservicecontrol--instance--forward_error_messages"></a>`forward_error_messages`

Data type: `Boolean`

Specify if audit messages are forwarded to the queue specified by ErrorLogQueue.

Default value: `false`

##### <a name="-nservicebusservicecontrol--instance--service_account"></a>`service_account`

Data type: `String`

The Account to run the Windows service.

Default value: `'LocalSystem'`

##### <a name="-nservicebusservicecontrol--instance--service_account_password"></a>`service_account_password`

Data type: `Optional[String]`

The password for the ServiceAccount.

Default value: `undef`

##### <a name="-nservicebusservicecontrol--instance--service_restart_on_config_change"></a>`service_restart_on_config_change`

Data type: `Boolean`

Specify if the service control instance's windows service should be restarted to pick up changes to its configuration file.

Default value: `true`

##### <a name="-nservicebusservicecontrol--instance--error_retention_period"></a>`error_retention_period`

Data type: `String`

Specify thd grace period that faulted messages are kept before they are deleted.

Default value: `'15.00:00:00'`

##### <a name="-nservicebusservicecontrol--instance--time_to_restart_error_ingestion_after_failure"></a>`time_to_restart_error_ingestion_after_failure`

Data type: `String`

Specify the maximum time delay to wait before restarting the error ingestion pipeline after detecting a connection problem. This setting was introduced in ServiceControl version 4.4.1.

Default value: `'00.00:01:00'`

##### <a name="-nservicebusservicecontrol--instance--disable_external_integrations_publishing"></a>`disable_external_integrations_publishing`

Data type: `Boolean`

Disable external integrations publishing.

Default value: `false`

##### <a name="-nservicebusservicecontrol--instance--enable_full_text_search_on_bodies"></a>`enable_full_text_search_on_bodies`

Data type: `Boolean`

Allows full text searches to happen on the body of messages. This setting was introduced in ServiceControl version 4.17.0.

Default value: `true`

##### <a name="-nservicebusservicecontrol--instance--event_retention_period"></a>`event_retention_period`

Data type: `String`

Specifies the period to keep event logs before they are deleted.

Default value: `'14.00:00:00'`

##### <a name="-nservicebusservicecontrol--instance--expiration_process_timer_in_seconds"></a>`expiration_process_timer_in_seconds`

Data type: `Integer`

Specifies the number of seconds to wait between checking for expired messages.

Default value: `600`

##### <a name="-nservicebusservicecontrol--instance--expiration_process_batch_size"></a>`expiration_process_batch_size`

Data type: `Integer`

Specifies the batch size to use when checking for expired messages.

Default value: `65512`

##### <a name="-nservicebusservicecontrol--instance--data_space_remaining_threshold"></a>`data_space_remaining_threshold`

Data type: `Integer`

The percentage threshold for the Message database storage space check. If the remaining hard drive space drops below this threshold (as a percentage of the total space on the drive), then the check will fail, alerting the user.

Default value: `20`

##### <a name="-nservicebusservicecontrol--instance--http_default_connection_limit"></a>`http_default_connection_limit`

Data type: `Integer`

Specifies the maximum number of concurrent connections allowed by ServiceControl.

Default value: `100`

##### <a name="-nservicebusservicecontrol--instance--heartbeat_grace_period"></a>`heartbeat_grace_period`

Data type: `String`

Specifies the period that defines whether an endpoint is considered alive or not since the last received heartbeat.

Default value: `'00:00:40'`

##### <a name="-nservicebusservicecontrol--instance--allow_message_editing"></a>`allow_message_editing`

Data type: `Boolean`

Enables the ability for servicepulse to allow users to edit failed messages before being retried.

Default value: `false`

##### <a name="-nservicebusservicecontrol--instance--notifications_filter"></a>`notifications_filter`

Data type: `String`

Configures notification filters.

Default value: `''`

##### <a name="-nservicebusservicecontrol--instance--minimum_storage_left_required_for_ingestion"></a>`minimum_storage_left_required_for_ingestion`

Data type: `Integer`

The percentage threshold for the Critical message database storage space check.

Default value: `5`

##### <a name="-nservicebusservicecontrol--instance--service_manage"></a>`service_manage`

Data type: `Boolean`

Specifies whether or not to manage the desired state of the windows service for this instance.

Default value: `true`

##### <a name="-nservicebusservicecontrol--instance--skip_queue_creation"></a>`skip_queue_creation`

Data type: `Boolean`

Normally an instance will attempt to create the queues that it uses. If this flag is set, queue creation will be skipped.

Default value: `false`

##### <a name="-nservicebusservicecontrol--instance--remove_db_on_delete"></a>`remove_db_on_delete`

Data type: `Boolean`

Remove service control instance ravendb database when instance is deleted.

Default value: `false`

##### <a name="-nservicebusservicecontrol--instance--remove_logs_on_delete"></a>`remove_logs_on_delete`

Data type: `Boolean`

Remove service control instance logs when instance is deleted.

Default value: `false`

##### <a name="-nservicebusservicecontrol--instance--automatic_instance_upgrades"></a>`automatic_instance_upgrades`

Data type: `Boolean`

Automatically upgrade the service control monitoring instance when a new version of servicecontrol is installed.

Default value: `true`

##### <a name="-nservicebusservicecontrol--instance--instance_create_and_upgrade_acknowledgements"></a>`instance_create_and_upgrade_acknowledgements`

Data type: `Optional[String]`

Acknowledge mandatory requirements have been met during instance creation and upgrades.

Default value: `undef`

### <a name="nservicebusservicecontrol--monitoring_instance"></a>`nservicebusservicecontrol::monitoring_instance`

Manages Service Control Monitoring Instances.

#### Parameters

The following parameters are available in the `nservicebusservicecontrol::monitoring_instance` defined type:

* [`ensure`](#-nservicebusservicecontrol--monitoring_instance--ensure)
* [`instance_name`](#-nservicebusservicecontrol--monitoring_instance--instance_name)
* [`install_path`](#-nservicebusservicecontrol--monitoring_instance--install_path)
* [`log_path`](#-nservicebusservicecontrol--monitoring_instance--log_path)
* [`instance_log_level`](#-nservicebusservicecontrol--monitoring_instance--instance_log_level)
* [`host_name`](#-nservicebusservicecontrol--monitoring_instance--host_name)
* [`port`](#-nservicebusservicecontrol--monitoring_instance--port)
* [`maximum_concurrency_level`](#-nservicebusservicecontrol--monitoring_instance--maximum_concurrency_level)
* [`endpoint_uptime_grace_period`](#-nservicebusservicecontrol--monitoring_instance--endpoint_uptime_grace_period)
* [`error_queue`](#-nservicebusservicecontrol--monitoring_instance--error_queue)
* [`transport`](#-nservicebusservicecontrol--monitoring_instance--transport)
* [`display_name`](#-nservicebusservicecontrol--monitoring_instance--display_name)
* [`connection_string`](#-nservicebusservicecontrol--monitoring_instance--connection_string)
* [`description`](#-nservicebusservicecontrol--monitoring_instance--description)
* [`service_account`](#-nservicebusservicecontrol--monitoring_instance--service_account)
* [`service_account_password`](#-nservicebusservicecontrol--monitoring_instance--service_account_password)
* [`service_restart_on_config_change`](#-nservicebusservicecontrol--monitoring_instance--service_restart_on_config_change)
* [`service_manage`](#-nservicebusservicecontrol--monitoring_instance--service_manage)
* [`skip_queue_creation`](#-nservicebusservicecontrol--monitoring_instance--skip_queue_creation)
* [`remove_logs_on_delete`](#-nservicebusservicecontrol--monitoring_instance--remove_logs_on_delete)
* [`automatic_instance_upgrades`](#-nservicebusservicecontrol--monitoring_instance--automatic_instance_upgrades)
* [`instance_create_and_upgrade_acknowledgements`](#-nservicebusservicecontrol--monitoring_instance--instance_create_and_upgrade_acknowledgements)

##### <a name="-nservicebusservicecontrol--monitoring_instance--ensure"></a>`ensure`

Data type: `Enum['present', 'absent']`

Specifies whether the monitoring instance should exist.

##### <a name="-nservicebusservicecontrol--monitoring_instance--instance_name"></a>`instance_name`

Data type: `String`

Specify the name of the ServiceControl Monitoring Instance (title).

Default value: `$title`

##### <a name="-nservicebusservicecontrol--monitoring_instance--install_path"></a>`install_path`

Data type: `Stdlib::Absolutepath`

Specify the directory to use for this ServiceControl Monitoring Instance.

Default value: `"C:\\Program Files (x86)\\Particular Software\\${instance_name}"`

##### <a name="-nservicebusservicecontrol--monitoring_instance--log_path"></a>`log_path`

Data type: `Stdlib::Absolutepath`

Specify the directory to use for this ServiceControl Monitoring Logs.

Default value: `"C:\\ProgramData\\Particular\\ServiceControl\\${instance_name}\\Logs"`

##### <a name="-nservicebusservicecontrol--monitoring_instance--instance_log_level"></a>`instance_log_level`

Data type: `Nservicebusservicecontrol::Log_level`

Specify the level of logging that should be used in ServiceControl Monitoring logs.

Default value: `'Warn'`

##### <a name="-nservicebusservicecontrol--monitoring_instance--host_name"></a>`host_name`

Data type: `Stdlib::Fqdn`

Specify the hostname to use in the URLACL.

Default value: `'localhost'`

##### <a name="-nservicebusservicecontrol--monitoring_instance--port"></a>`port`

Data type: `Stdlib::Port`

Specify the port number to listen on. If this is the only ServiceControl Monitoring instance then 33633 is recommended.

Default value: `33633`

##### <a name="-nservicebusservicecontrol--monitoring_instance--maximum_concurrency_level"></a>`maximum_concurrency_level`

Data type: `Integer`

This setting controls how many messages can be processed concurrently (in parallel) by ServiceControl.

Default value: `32`

##### <a name="-nservicebusservicecontrol--monitoring_instance--endpoint_uptime_grace_period"></a>`endpoint_uptime_grace_period`

Data type: `String`

The grace period for endpoint uptime.

Default value: `'00:00:40'`

##### <a name="-nservicebusservicecontrol--monitoring_instance--error_queue"></a>`error_queue`

Data type: `String`

Specify the ErrorQueue name.

Default value: `'error'`

##### <a name="-nservicebusservicecontrol--monitoring_instance--transport"></a>`transport`

Data type: `Nservicebusservicecontrol::Transport`

Specify the NServiceBus Transport to use.

Default value: `'MSMQ'`

##### <a name="-nservicebusservicecontrol--monitoring_instance--display_name"></a>`display_name`

Data type: `String`

Specify the Windows Service Display name. If unspecified the monitoring instance name will be used.

Default value: `$instance_name`

##### <a name="-nservicebusservicecontrol--monitoring_instance--connection_string"></a>`connection_string`

Data type: `Optional[String]`

Specify the connection string to use to connect to the queuing system.

Default value: `undef`

##### <a name="-nservicebusservicecontrol--monitoring_instance--description"></a>`description`

Data type: `String`

Specify the description to use on the Windows Service for this instance.

Default value: `'A Monitoring Instance'`

##### <a name="-nservicebusservicecontrol--monitoring_instance--service_account"></a>`service_account`

Data type: `String`

The Account to run the Windows service.

Default value: `'LocalSystem'`

##### <a name="-nservicebusservicecontrol--monitoring_instance--service_account_password"></a>`service_account_password`

Data type: `Optional[String]`

The password for the ServiceAccount.

Default value: `undef`

##### <a name="-nservicebusservicecontrol--monitoring_instance--service_restart_on_config_change"></a>`service_restart_on_config_change`

Data type: `Boolean`

Specify if the servicecontrol monitoring instance's windows service should be restarted to pick up changes to its configuration file.

Default value: `true`

##### <a name="-nservicebusservicecontrol--monitoring_instance--service_manage"></a>`service_manage`

Data type: `Boolean`

Specifies whether or not to manage the desired state of the windows service for this instance.

Default value: `true`

##### <a name="-nservicebusservicecontrol--monitoring_instance--skip_queue_creation"></a>`skip_queue_creation`

Data type: `Boolean`

Normally an instance will attempt to create the queues that it uses. If this flag is set, queue creation will be skipped.

Default value: `false`

##### <a name="-nservicebusservicecontrol--monitoring_instance--remove_logs_on_delete"></a>`remove_logs_on_delete`

Data type: `Boolean`

Specifies if the service control logs should be deleted with the instance.

Default value: `false`

##### <a name="-nservicebusservicecontrol--monitoring_instance--automatic_instance_upgrades"></a>`automatic_instance_upgrades`

Data type: `Boolean`

Automatically upgrade the service control monitoring instance when a new version of servicecontrol is installed.

Default value: `true`

##### <a name="-nservicebusservicecontrol--monitoring_instance--instance_create_and_upgrade_acknowledgements"></a>`instance_create_and_upgrade_acknowledgements`

Data type: `Optional[String]`

Acknowledge mandatory requirements have been met during instance creation and upgrades.

Default value: `undef`

### <a name="nservicebusservicecontrol--retry_redirect"></a>`nservicebusservicecontrol::retry_redirect`

Manages Retry Redirects.

#### Parameters

The following parameters are available in the `nservicebusservicecontrol::retry_redirect` defined type:

* [`ensure`](#-nservicebusservicecontrol--retry_redirect--ensure)
* [`source_queue`](#-nservicebusservicecontrol--retry_redirect--source_queue)
* [`destination_queue`](#-nservicebusservicecontrol--retry_redirect--destination_queue)
* [`service_control_url`](#-nservicebusservicecontrol--retry_redirect--service_control_url)

##### <a name="-nservicebusservicecontrol--retry_redirect--ensure"></a>`ensure`

Data type: `Enum['present', 'absent']`

Specifies whether the retry redirect should exist.

##### <a name="-nservicebusservicecontrol--retry_redirect--source_queue"></a>`source_queue`

Data type: `String`

Specify the queue for which this redirect will be applied.

Default value: `$title`

##### <a name="-nservicebusservicecontrol--retry_redirect--destination_queue"></a>`destination_queue`

Data type: `String`

Specify the queue that will be the new destination when retrying.

##### <a name="-nservicebusservicecontrol--retry_redirect--service_control_url"></a>`service_control_url`

Data type: `String`



## Data types

### <a name="Nservicebusservicecontrol--Log_level"></a>`Nservicebusservicecontrol::Log_level`

Supported log levels for servicecontrol

Alias of `Enum['Trace', 'Debug', 'Info', 'Warn', 'Error', 'Fatal', 'Off']`

### <a name="Nservicebusservicecontrol--Transport"></a>`Nservicebusservicecontrol::Transport`

Supported NServicebus transports

Alias of `Enum['RabbitMQ - Conventional routing topology', 'RabbitMQ - Conventional routing topology (classic queues)', 'RabbitMQ - Conventional routing topology (quorum queues)', 'SQL Server', 'MSMQ', 'Azure Storage Queue', 'Azure Service Bus', 'AmazonSQS']`

## Tasks

### <a name="get_instances"></a>`get_instances`

Gets all servicecontrol instances.

**Supports noop?** false

## Plans

### <a name="nservicebusservicecontrol--compact_database"></a>`nservicebusservicecontrol::compact_database`

Compacts the servicecontrol instance's RavenDB Database.

#### Parameters

The following parameters are available in the `nservicebusservicecontrol::compact_database` plan:

* [`targets`](#-nservicebusservicecontrol--compact_database--targets)
* [`instance_name`](#-nservicebusservicecontrol--compact_database--instance_name)

##### <a name="-nservicebusservicecontrol--compact_database--targets"></a>`targets`

Data type: `TargetSpec`

Targets to compact databases.

##### <a name="-nservicebusservicecontrol--compact_database--instance_name"></a>`instance_name`

Data type: `String[1]`

The name of the servicecontrol instance.

### <a name="nservicebusservicecontrol--import_failed_messages"></a>`nservicebusservicecontrol::import_failed_messages`

Imports failed error or audit messages.

#### Parameters

The following parameters are available in the `nservicebusservicecontrol::import_failed_messages` plan:

* [`targets`](#-nservicebusservicecontrol--import_failed_messages--targets)
* [`instance_name`](#-nservicebusservicecontrol--import_failed_messages--instance_name)
* [`instance_type`](#-nservicebusservicecontrol--import_failed_messages--instance_type)

##### <a name="-nservicebusservicecontrol--import_failed_messages--targets"></a>`targets`

Data type: `TargetSpec`

Targets to import failed messages on.

##### <a name="-nservicebusservicecontrol--import_failed_messages--instance_name"></a>`instance_name`

Data type: `String[1]`

The name of the servicecontrol instance.

##### <a name="-nservicebusservicecontrol--import_failed_messages--instance_type"></a>`instance_type`

Data type: `Enum['error', 'audit']`

The servicecontrol instance type (Audit or Error).

